


  '---------------------
  Type VertexArrayObject
  '=====================
  '
  n   As Long    'VERTICES
  v   As bstring 'VERTEX  ARRAY
  w   As bstring 'NORMAL  ARRAY
  c   As bstring 'COLOR   ARRAY
  t   As bstring 'TEXCOOR ARRAY
  tex As bstring 'TEXTURE ARRAY
  '
  pv As Long 'VERTEX POINTER
  pw As Long 'NORMAL POINTER
  pc As Long 'COLOR  POINTER
  pt As Long 'TEXCOR POINTER
  '
  End Type
  

  '-----------------------------------------------------
  Sub ArrayBuffer_Render(va As VertexArrayObject) At #p3
  '=====================================================
  '
  'ENABLE ARRAYS
  '-------------

  glEnableClientState GL_VERTEX_ARRAY        ' -- Vertices
  glEnableClientState GL_NORMAL_ARRAY        ' -- Vertices
  glEnableClientState GL_TEXTURE_COORD_ARRAY ' -- Vertices
  glEnableClientState GL_COLOR_ARRAY         ' -- Colors
  
  'RENDER
  '------
  
  glVertexPointer   3, GL_FLOAT, 0, va.pv
  glNormalPointer   GL_FLOAT, 0, va.pw
  glTexCoordPointer 2, GL_FLOAT, 0, va.pt
  glColorPointer    3, GL_FLOAT, 0, va.pc

  glDrawArrays      GL_QUAD_STRIP, 0, va.n

  'DISABLE ARRAYS
  '--------------
  
  glDisableClientState GL_COLOR_ARRAY
  glDisableClientState GL_TEXTURE_COORD_ARRAY
  glDisableClientState GL_NORMAL_ARRAY 
  glDisableClientState GL_VERTEX_ARRAY
  '
  End Sub


  '---------------------------------------------------------------------------------------------------------
  Sub MakeTexture(ByVal TexNum As Long ,ByVal PixelArray As Long, ByVal xSize As Long, ByVal ySize As Long )
  '=========================================================================================================
  '
  glBindTexture GL_TEXTURE_2D, texNum
  glTexParameteri GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR
  glTexParameteri GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR '_MIPMAP_LINEAR ' _MIPMAP_LINEAR
  glTexImage2D GL_TEXTURE_2D, 0, 4, xSize, ySize, 0, GL_RGBA, GL_UNSIGNED_BYTE, PixelArray
  '
  End Sub


  '-------------------------------------------------------------
  Sub texture1(va As vertexArrayObject, ByVal n As Long) At #p5
  '=============================================================
  *va.tex=>
  0,  0,  0, 0,
  0, -1, 0x88ffffff, 0,
  0, 0x88ffffff, -1, 0,
  0,  0,  0, 0 
  MakeTexture n, ?va.tex, 4, 4
  End Sub

