
  '==========
  'LeanLisp 1
  '==========

  'Charles Pegge
  '07:21 27/01/2011
  '09:58 16/04/2011  port o2


  type deft
    n as string
    d as string
    t as long
  end type


  long    asci,bw,defi,i,j,k,lens,dtf,numf,op,opf,printf,nest,doi,spt
  long    nestop[64],nestopf[64],dos[64,4]
  double  v,accum,nestacc[64]
  string  s,t,u,w,accs,prints,nestaccs[64],wp[10],stk[64]
  deft    defd[8000]




  '-----------------------------------------
  sub stepword(s as string, byref i as long)
  '=========================================
  dim as long a,b
  '
  do
    asci=asc(s,i)
    if asci<9 then exit do
    if asci>32 then exit do
    i+=1
  loop
  '
  b=i : dtf=0
  '
  'CHECK FOR '('  ')' AND QUOTE MARKS
  '
  if (asci=40)or(asci=41)or(asci=255) then
    i+=1
  elseif (asci=34)or(asci=96) then ' " `
    i=instr(b+1,s,chr(asci))
    if i=0 then i=len(s)
    i+=1
  else
    '
    do
      a=asc(s,i)
      if a=46 then
        if dtf=0 then dtf=i-b+1
      end if
      if (a<=32)or(a=40)or(a=41) then exit do 'bracket or space encountered
      i+=1
    loop
    '
  end if
  bw=b
  end sub



  '------------------------------------------
  sub stepblock(s as string, byref i as long)
  '==========================================
  '
  dim as long a,b,n
  stepword(s,i)
  a=asci : b=bw
  lens=0
  '
  if asci=40 then
    do
      stepword(s,i)
      select case asci
      case 0 : exit while
      case 40 : n+=1 : if n=1 then lens+=1
      case 41 : n-=1 : if n<0 then exit do
      end select
    loop
  end if
  'err if n>=0
  bw=b : asci=a
  if (asci=34)or(asci=96) then lens=i-bw-2
  end sub

  '-------------------------------------------------------
  function getword(s as string, byref i as long) as string
  '=======================================================
  stepword(s,i)
  function=mid(s,bw,i-bw)
  end function


  '--------------------------------------------------------
  function getblock(s as string, byref i as long) as string
  '========================================================
  stepblock(s,i)
  function=mid(s,bw,i-bw)
  end function

  '----------------------------------------
  sub stepend(s as string, byref i as long)
  '========================================
  '
  dim as long b,n
  b=i
  do
    stepword(s,i)
    select case asci
    case 40 : n+=1
    case 41 : n-=1 : if n<0 then exit do
    end select
  loop
  bw=b
  'err if n>=0
  end sub


  '-----------
  sub opeval()
  '===========
  '
  if (asci=34)or(asci=96) then
    if numf=1 then accs+=str(accum) : accum=0 : numf=0
    if (op=43)or(op=0) then accs+=mid(t,2,len(t)-2) 'append string
  elseif numf=1 then
    if opf then
      accum=v
      opf=0
    else
      select case op
      case 0  : accum=v
      case 43 : accum+=v
      case 45 : accum-=v
      case 42 : accum*=v
      case 47 : accum/=v
      end select
    end if
  else 'string or literal
    if opf then
      accs=t
      opf=0
    else
      select case op
      case 0  : accs=t
      case 43 : accs+=t
      end select
    end if
  end if
  end sub


  '-----------------------------------
  function lookup(w as string) as long
  '===================================
    dim as long k
    for k=defi to 1 step-1
      if w=defd(k).n then function=k : k=0
    next
  end function

  '-----------------------------------------------------------------------
  sub assigns(s as string,byref i as long,byval d as long, byval f as long)
  '=======================================================================
  dim as long ii
  dim as string ls
  ls=getblock(s,i)
  if f then
    ii=1 : evaluate(ls,ii) 'recursive evaluation
    if numf=1 then
      t+=str(v) 'values
    elseif numf=0 then
      t=chr(34)+t+chr(34) 'strings
    end if
  else 'quoted assign
    t=ls
  end if
  defd(d).d=t
  defd(d).t=numf
  t="" : numf=0
  end sub

  '------------------------------------------------------
  sub lets(s as string, byref i as long, byval f as long)
  '======================================================
  dim as long d
  w=getword(s,i)
  defi+=1
  d=defi
  defd(d).n=w
  assigns(s,i,d,f)
  end sub

  '------------------------------------------------------
  sub sets(s as string, byref i as long, byval f as long)
  '======================================================
  dim as long a,d
  dim as string ls
  w=getword(s,i)
  a=lookup(w)
  if a=0 then
    defi+=1 : d=defi
    defd(d).n=w
   else
     d=a
  end if
  assigns(s,i,d,f)
  end sub


  '------------------------------------------
  sub evalblock(s as string, byref i as long)
  '==========================================
  dim as long ii
  dim as string ws
  ws=stepword(s,i)
  i=bw
  if asci<>41 then
    'ii=1 : evaluate(ws,ii)
    evaluate(s,i)
    asci=0
  end if
  end sub

  '---------------------------------------
  function resolve(w as string) as string
  '=======================================
  '
  'return literals (from literals or variables)
  '
  dim as long a
  dim as string ws
  ws=w
  a=asc(ws)
  '
  'check alphanumeric (variable)
  '
  if (a>&h60)and(a<=&h7a) then
    if ws="pop" then
      if spt then
        ws=stk(spt)
       spt-=1
       a=1
      end if
    else
      a=lookup(ws)
      if a then ws=defd(a).d
    end if
    '
    if a then
      a=1 : stepblock(ws,a) 'counts items: lens
    end if
  end if
  function=ltrim(ws)
  asci=asc(ws)
  end function


  '-----------------------------------------------------------
  sub defmac(s as string,byref i as long ,byref ls as string)
  '===========================================================
  dim as long a,b,c,ii
  dim as string ks
  a=1
  do
    a=instr(a,ls,"%")
    if a=0 then exit do
    b=asc(ls,a+1)-48
    '
    if (b<1)or(b>9) then
      '
      '%n  'REST AFTER OTHER PARAMS
      a+=2 'BYPASS
      '
    elseif b>c then
      '
      '%1..%9
      '
      ii=c+1
      while ii<=b
        '
        'SUBSTITUTION OF LITERAL OR VARIABLE
        '
        ks=getblock(s,i)
        if asci=41 then
          i-=1 : ks="" 'no further params available
        else
          if ks="quote" then
            ks=getblock(s,i)
          else
            ks=resolve(ks) 'get value if a variable
          end if
        end if
        wp(ii)=ks
        numf=0
        ii+=1
      wend
      c=b
    end if
    if (b>0)and(b<10) then
      ls=left(ls,a-1)+wp(b)+mid(ls,a+2)
    end if
  loop
  '
  a=1
  c=0
  do
    a=instr(a,ls,"%n") 'CHECK FOR REST (itr all literal)
    if a=0 then exit do
    if c=0 then stepend(s,i) : i-=1 : c=1
    ls=left(ls,a-1)+mid(s,bw,i-bw)+mid(ls,a+2)
    a+=i-bw
  loop
  end sub


  '-----------------------------------------------
  sub evaluate(byref s as string, byref i as long)
  '===============================================
  dim as long a,b,c,d,ii,jj,kk,pd,pn
  dim as double lv,rv
  dim as string ks,ls,ws
  'ld=defi 'scope
  pn=nest 'nesting level
  pd=doi  'do block level
  do
    w=getword(s,i)
    if w="" then exit do
    '
    '---------------------
    'SINGLE CHAR OPERATORS
    '---------------------
    '
    if i=bw+1 then
      select case asci
      '
      '
      '--------------------
      case 0 'end of string
      '--------------------
        '
        exit do
        '
      '--------------------------
      case 40 '(' opening bracket
      '--------------------------
      ' '
        nest+=1
        nestacc(nest)=accum : nestaccs(nest)=accs
        nestop(nest)=op : nestopf(nest)=opf
        accum=0 : accs="" : op=0 : opf=0 : numf=0
        '
      '--------------------------
      case 41 ')' closing bracket
      '--------------------------
        '
        if nest<=pn then asci=256 : exit do 'boundary mark
        '
        v=accum : accum=nestacc(nest)
        t=accs : accs=nestaccs(nest)
        op=nestop(nest) : opf=nestopf(nest)
        nest-=1
        opeval()
        if printf>nest then
          if numf=1 then t+=str(accum)
          msgbox 0,t 'DISPLAY
          printf=0
          if op<>43 then accs=""
        end if
        '      
        w="" : asci=41
        '
      '--------------------
      'ARITHMETIC OPERATORS
      '--------------------
        '
      case 43 : op=43 : opf=1 '+'
        '
      case 45 : op=45 : opf=1 '-'
        '
      case 42 : op=42 : opf=1 '*'
        '
      case 47 : op=47 : opf=1 '/'
        '
      end select
      '
    end if 'single char ops
    '
    '-----------
    'COMPARATORS
    '-----------
    '
    if w="=" then
      op=201
    elseif w="<" then
      op=202
    elseif w="<=" then
      op=203
    elseif w=">" then
      op=204
    elseif w=">=" then
      op=205
    elseif w="<>" then
      op=206
    end if
    '
    if op>200 then
      b=op
      op=0
      evalblock(s,i)
      if numf=1 then
        lv=v
      else
        ls=t
      end if
      op=0
      evalblock(s,i)
      if numf=1 then
        rv=v
      else
        ws=t
      end if
      '
      'CHECK TRUE/FALSE
      '
      if numf=1 then
        accum=0
        select case b
        case 201 : if lv=rv  then accum=-1
        case 202 : if lv<rv  then accum=-1
        case 203 : if lv<=rv then accum=-1
        case 204 : if lv>rv  then accum=-1
        case 205 : if lv>=rv then accum=-1
        case 206 : if lv<>rv then accum=-1
        end select
      else
        accum=0 : numf=1
        select case b
        case 201 : if ls=ws  then accum=-1
        case 202 : if ls<ws  then accum=-1
        case 203 : if ls<=ws then accum=-1
        case 204 : if ls>ws  then accum=-1
        case 205 : if ls>=ws then accum=-1
        case 206 : if ls<>ws then accum=-1
        end select
      end if
      iterate do
    end if
    '
    '------------------------------------------
    'LITERAL NUMBER (INCLUDING MINUS AND POINT)
    '------------------------------------------
    '
    if (asci>=45)and(asci<=57) then
      '
      if asci<>47 then
        numf=1
        v=val(w)
        opeval()
      end if
      '
    elseif (asci=34)or(asci=96) then
      '
      '--------------------------
      'LITERAL STRING (IN QUOTES)
      '--------------------------
      '
      t=w : opeval()
     '
    elseif asci=39 then
      '
      '-----------------------
      'REST OF LINE IS COMMENT
      '-----------------------
      '
      i=instr(i,s,chr(10))
      if i=0 then i=len(s)+1
      iterate do ' continue
      '
    else 'not a literal number or string
      '
      '
      '--------------
      'CORE OPERATORS
      '==============
      '
      '----------------
      if w="quote" then
      '----------------
        '
        numf=2
        if op<>43 then accs=""
        accs+=getblock(s,i)
        '
      '-----------------------
      elseif w="inner" then
      '-----------------------
        '
        'accs=resolve(getblock(s,i))
        evalblock(s,i)
        ls=ltrim(rtrim(accs))
        b=1 : a=asc(ls) : c=len(ls)+1
        if (a=34)or(a=96)or(a=40) then b=2 : c-=1
        accs=mid(ls,b,c-b) : op=0 : numf=2
        '
      '-----------------------
      elseif w="combine" then
      '-----------------------
        '
        ls=" "
        '
        'resolve macros/variables
        '
        do
          ws=getblock(s,i)
          if asci=41 then i-=1 : exit do
          ws=resolve(ws)
          if asci=40 then
            ws=mid(ws,2,len(ws)-2)
          end if
          ls+=ws+" "
        loop
        accs="("+ls+")" : op=0 : numf=2
        '
      '--------------------
      elseif w="return" then
      '--------------------
        '
        ii=1 : evalblock(s,i)
        if asci=41 then accs=t : accum=v
        nest=pn : i=len(s)+1
        '
      '--------------------
      elseif w="print" then
      '--------------------
        '
        numf=0 : op=43 : opf=1
        printf=nest
        '
      '---------------------
      elseif w="do" then
      '---------------------
        '
        doi+=1
        dos(doi,1)=i
        b=i
        stepend(s,i)
        dos(doi,2)=i-1
        dos(doi,3)=nest
        dos(doi,4)=defi
        i=b
        '
      '---------------------
      elseif w="repeat" then
      '---------------------
        '
        i=dos(doi,1)
        nest=dos(doi,3)
        '
      '---------------------
      elseif w="exit" then
      '---------------------
        '
        if doi>0 then
          i=dos(doi,2)
          nest=dos(doi,3)
          defi=dos(doi,4)
          doi-=1
        end if
        '
      '---------------------
      elseif w="len" then
      '---------------------
        '
        ls=resolve(getblock(s,i))
        numf=1 : accum=lens
        '
      '---------------------
      elseif w="mid" then
      '---------------------
        '
        ls=resolve(getblock(s,i))
        a=asci : c=lens
        evalblock(s,i) : b=accum
        evalblock(s,i) : c=accum
        '
        'STRING
        '
        if (a=34)or(a=96) then
          ls=mid(ls,2,len(ls)-2)
          numf=0 : accs=chr(34)+mid(ls,b,c)+chr(34)
        else
          '
          'LIST ELEMENTS
          '
          ii=2
          for j=1 to b-1
            stepblock(ls,ii)
            if asci=41 then j=b : ii-=1
          next
          a=ii
          if asci<>41 then
            for j=1 to c
              stepblock(ls,ii)
              if asci=41 then j=c
            next
          end if
          numf=0 : accs="("+mid(ls,a,ii-a)+")"
        end if
        '
      '---------------------
      elseif w="next" then
      '---------------------
        w=getword(s,i)
        accum=-1 : numf=1 'bool for cond
        defi+=1 : ii=1
        defd(defi).n=w
        a=lookup("params") : w=""
        if a then
          w=getblock(defd(a).d,ii)
          defd(a).d=mid(defd(a).d,ii) 'destructive read
          if asci=41 then w="" : accum=0
        else
          accum=0
        end if
        defd(defi).d=w
        defd(defi).t=0
        '
      '------------------
      elseif w="cond" then
      '------------------
        'CONDITIONAL/ EXEC PAIRS
        '
        '(cond (> a b) (print "a>b" ) (<= ab ) (print "a<=b") )
        '
        do
          op=0
          evalblock(s,i)
          if asci=41 then i-=1 : exit do
          '
          c=0
          if numf=1 then
            if accum<>0 then c=1
          else
            if accs then c=1
          end if
          '
          if c=1 then
            evalblock(s,i)
          else
            stepblock(s,i)
          end if
        loop
        '
      '------------------
      elseif w="if" then
      '------------------
        '
        'CONDITIONAL IF / ELSE
        '(if (> a b) (print "a>b" ) (print "a<=b") )
        '
        evalblock(s,i)
        '
        c=0
        if numf=1 then
          if accum<>0 then c=1
        else
          if accs then c=1
        end if
        '
        if c then
          evalblock(s,i) 'evaluate 'if' clause
          stepblock(s,i) 'skip else
        else
          stepblock(s,i) 'skip if
          evalblock(s,i) 'evaluate 'else' clause
        end if
        '
      '------------------
      elseif w="def" then
      '------------------
        '
        'CREATE SYMBOL AND MACRO
        '
        w=getword(s,i)
        stepend(s,i) : i-=1
        defi+=1
        defd(defi).n=w
        defd(defi).t=255
        defd(defi).d=mid(s,bw,i-bw)
        '
      '------------------
      elseif w="fun" then
      '------------------
        '
        'CREATE FUNCTION
        '(fun (foo a b) (+ a b) )
        '
        stepblock(s,i)
        ii=bw+1 : w=getword(s,ii) : b=ii
        stepend(s,i) : i-=1
        defi+=1
        defd(defi).n=w
        defd(defi).t=254
        defd(defi).d=mid(s,b,i-b)
        '
      '------------------
      elseif w="let" then
      '------------------
        '
        'CREATE SYMBOL AND EVALUATE
        '
        lets(s,i,1)
        '
       '------------------
      elseif w="letq" then
      '------------------
        '
        'CREATE SYMBOL AND EVALUATE
        '
        lets(s,i,0)
        '
      '------------------
      elseif w="set" then
      '------------------
        '
        'CREATE SYMBOL AND EVALUATE
        '
        sets(s,i,1) 'evaluates
        '
      '------------------
      elseif w="setq" then
      '------------------
        '
        'CREATE SYMBOL AND EVALUATE
        '
        sets(s,i,0) 'set quoted
        '
      elseif w="sqrt" then
        '
        evalblock(s,i) : accum=sqr(accum)
        '
      '------------------
      elseif w="inc" then
      '------------------
        '
        w=getword(s,i)
        a=lookup(w)
        if a then
          w=defd(a).d
          defd(a).d=str(val(w)+1)
          defd(a).t=1
        end if
        '
      '------------------
      elseif w="dec" then
      '------------------
        '
        w=getword(s,i)
        a=lookup(w)
        if a then
          w=defd(a).d
          defd(a).d=str(val(w)-1)
          defd(a).t=1
        end if
        '
      '------------------
      elseif w="push" then
      '------------------
        '
        'PUSH ACCUM (+ 1 2 3 push 4 5 6 push )
        '
        spt+=1
        'err if spt>64
        ws=accs : if numf=1 then ws+=str(accum)
        stk(spt)=ws
        '
      '------------------
      elseif w="pop" then
      '------------------
        '
        'POP VALUE ( + 1 pop )
        '
        if spt then
          t=stk(spt)
          if numf=1 then v=val(t)
          spt-=1
          opeval()
        end if
        '
      else
        '
        '-------------
        'LOCATE SYMBOL
        '-------------
        '
        if len(w) then
          b=lookup(w)
          if b=0 then
            'err symb not defined or out of scope
          else 'if b then
            '
            ls=defd(b).d
            a=defd(b).t
            ii=1
            '
            if a=254 then
              '
              '-------------------
              'FUNCTION / OPERATOR
              '-------------------
              '
              'set params def
              'compose procedure
              '
              d=defi 'mark scope
              '
              defi+=1
              defd(defi).n="params"
              defd(defi).d=""
              kk=defi
              '
              do
                '
                'assume matching param count
                '
                w=getword(ls,ii)
                if asci=41 then ii-=1 : w="sink"
                if w="rest" then
                  stepend(s,i)
                  defd(kk).d=mid(s,bw,i-bw)
                else
                  ks=getblock(s,i)
                end if
                if asci=41 then
                  i-=1 : ii+=1 : exit do
                end if
                if ks="quote" then
                  ks=getblock(s,i)
                else
                  ks=resolve(ks) 'get value if a variable
                end if
                ws=w+" "+ks
                jj=1 : lets(ws,jj,1)
                '
              loop
              '
              evaluate(ls,ii) 'recursive evaluation
              'catch return value
              '
              defi=d 'out of scope
              '
            else
              '
              '---------------
              'EVALUATE DIRECT
              '---------------
              '
              if a=255 then
                '
                '-------------------
                'SUBSTITUTE % PARAMS
                '-------------------
                '
                defmac(s,i,ls) : ii=2
                evaluate(ls,ii) 'recursive
                '
              else
                '
                '---------
                'VARIABLES
                '---------
                '
                numf=0
                t=ltrim(ls) : v=val(t) : a=asc(t)
                if (a=34)or(a=96) then
                  '
                elseif (v<>0)or(a=45)or(a=46)or(a=48) then
                  numf=1
                elseif a=40 then
                  numf=2
                end if
                asci=a
                opeval()
                '
              end if
              '
            end if
            '
          end if
        end if
      end if
    end if
    if nest<=pn then t=accs : exit do
    'a=GetAsyncKeyState(27)
    'if a then exit do
  loop
  'defi=ld 'remove scope
  if doi>pd then doi=pd  'clear any remaining do blocks
  end sub
  '
  'i=1
  's=getfile "LLisp.txt"
  'evaluate(s,i)
