

' ##          ##
' ####        ##
' ## ##       ##
' ##  ##      ##
' ##   ##     ##
' ##    ##    ##
' ##     ##   ##
' ##      ##  ##
' ##       ## ##
' ##        ####
' ##          ##


'------------------------------------------
sub enums(byref s as string,byref i as sys)
'==========================================
  dim as sys a,b,c,d,e,k,m
  dim as string wr,wd,wn,w1
  '
  wr=tword(s,i) 'ENUM/DEFS
  '
  if wordahead(s,i)="bit" then k=-3 : i=nwd else k=-2
  '
  nextinstruct(s,i)
  wn=tword(s,i) 'NAME PROVIDED?
  '
  if (ascw=lbr)or(ascw=123) then i=swd : ascn=ascw : wn="typedefenum" 'else nextinstruct(s,i)
  '
  captureb(s,i,m,b,wr) : e=m+b
  d=1 : c=0 : wd=" "
  '
  'start with value of 0
  'or 1 for bitwise
  '
  do
    if m>=e then exit do
    wr=tword(s,m)
    if ascn=61 then
      m+=1 : nextinstruct(s,m) 'SKIP `=`
    end if
    if isn(ascn) then
      wordval(s,m,m) : d=dv : c=dv
    else
      if isx(ascn)=0 then
        w1=tword(s,m)
        '
        'lookup existing value
        '
        a=instrword(wd,w1)
        if a then
          w1=tword(wd,a+len(w1)) 'internal
        else
          w1=mword(w1,1) 'elsewhere
        end if
        wordval(w1,1,1) : c=dv : d=dv
        skiplspace(s,m)
      end if
    end if
    if k=-3 then c=d : d+=d 'BITWISE ENUM
    wd+=" "+wr+" "+str(c)+cr
    if k=-2 then c+=1       'NORMAL ENUM
    if ascn=44 then m+=1    'SKIP COMMA
    nextinstruct(s,m)
  loop
  '
  macoin me
  macsi(wn,me,0) : addm(me)
  macsi(wd,me,1)
  maco(me,0)=-2
  maco(me,5)=cpuw
  addme
  skiplspace(s,i)
end sub



'=====================================
'             VARIABLES
'=====================================
'
'
'  ###         ###   ###   #########
'   ##         ##   #####   ##      ##
'    ##  VAR  ##   ##   ##   ##      ##
'     ##     ##   ##    ##    #######
'      ##   ##   ### DIM ##    ##    ##
'       #####   ##        ##    ##    ##
'        ###   ##          ##    ##    ##
'
'=========================================
'             DIM ----> VAR
'=========================================



'------------------------------------------
sub vars(byref s as string, byref i as sys)
'==========================================
    dim as sys a,b,c,k,m,n,v,w,it,poff,arv,tyi
    dim as string w1,w2,w3,wd,wr,wm,ws,wt,sigs
    '
    ' create variable and optionally associate with structure
    ' macs 0 name
    ' macs 1 macro (no structure spec)
    ' macs 2 regs and dimensions (if array)
    ' macs 3 name of intrinsic type
    '------------------------------
    ' maco 0 0 or type index
    ' maco 1 size
    ' maco 2 offset
    ' maco 3 indirection flag
    ' maco 4 number of array elements
    ' maco 5 type code >=512 = user defined
    '------------------------------
    '
    '=====
    varss:
    '=====
    '
    if wordahead(s,i)="var" then i=nwd
    '
    skiplspace(s,i)
    ind=0
    '
    'GET TYPE NAME
    '-------------
    '
    wm=tword(s,i)

    if wm="" then
      ers="No variables to declare " : ert= 100 : exit sub
    end if
    '
    '
    'TYPE POINTERS
    '-------------
    '
    'do
    '  w1=wordahead(s,i)
    '  if (w1="*")or(w1="ptr") then ind+=1 : i=nwd : continue do
    '  exit do
    'loop
    '
    '
    w=wval(wm)
    '
    if (w=0)and(ascw<>48) then
      '
      'IDENTIFY TYPE
      '
     it=identype(wm)
     if it=0 then ers="type not located: "+wm+":" : ert=14 : exit sub
     ind+=indt 'ADD TYPE INDIRECTION
     if it<0 then
        wr="void"
        if ind then
          ind-=1 : it=cpuw : lent=cpuw 'treat void* as direct system type
        else
          ers="direct void type not usable: "+wm+":" : ert=13 : exit sub
        end if
      end if
      tyi=lookupm(wm)
      '
      '
      '=========
      nidentify:
      '=========
      '
      w=lent
      '
      if it>=512 then
        k=it-512  'CLASS OR UDT
      end if
    end if
    ws=""
    '
    '
    'CHECK FOR FUNCTION POINTERS (*foo[n])(..)
    '-----------------------------------------
    '
    '
    if asc(ary)=40 then
      b=2
      w1=tword(ary,b)
      if ascw=42 then
        w1=tword(ary,b) 'SWALLOW FUNCTION NAME
        w2="" : a=b
        do
          skiplspace(ary,b)
          if ascn=91 then
            a=b
            b=instr(b,ary,"]") : if b=0 then exit do
            b+=1 : w2+=mid(ary,a,b-a)
          else
            exit do
          end if
        loop
        b=a : skiplspace(ary,b)
        if ascn=rbr then skiplspace(ary,b)
        '
        'CAPTURE SIGNATURE
        '
        if ascn=lbr then
          capturi(ary,m,b,a)
          m+=1 : sigs=namesig(ary,m)
        end if
        ary=w2 : k=&h1ff : it=k : w=cpuw 'FUNCTION PTR 32 OR 64 BITS
      end if
    end if
    
    ascn=ascl(s,i)
    '
    '
    '
    '-------------
    'each variable
    '=============
    '
    do ' each variable on line
      '
      macoin me
      arv=len(ary)
      '
      maco(me,3)=ind 'INITIAL LEVEL OF INDIRECTION
      macsi(wm+" "+sigs,me,3)
      '
      '-----------
      'indirection
      '===========
      '

      do
        if iss(ascn) then w3="" : exit do
        w3=tword(s,i)
        vword(s,i,w3)
        if ascw=44 then continue do
        if instrword(" * ptr pointer ",w3) then
          maco(me,3)+=1 : arv=0 : continue do 'POINTERS
        end if
        exit do
      loop
      '
      if w3="" then exit do
      '
      '
      'WATCH OUT FOR BSTRING PARAMS
      '============================
      '
      c=maco(me,3)
      '
      if (it and &hffe0)=&he0 then
        if (lclv>0)and(asce=1) then ' bstr params
          if c then maco(me,3)-=1 : c-=1 : else it-=32 'BSTR BYVAL
        end if
      end if
      '
      set_macro_name(w3)
      maco(me,0)=k ' structure index
      v=w
      maco(me,1)=w               'ELEMENT LENGTH (ignoring indrection)
      if c then v=cpuw 'POINTER LENGTH
      '
      maco(me,5)=it  ' type code
      '
      '
      '---------
      'CONSTANTS
      '=========
      '
      'simple constants
      '
      if cnst then
        if ascn=61 then i+=1 : nextinstruct(s,i) 'skip assign
        dv=metaval(s,i,w1)
        if asc(w1)=iq4 then
          if it<&hc0 then
            it=&hc1
          elseif it>&he0 then
            it-=32
          end if
          maco(me,5)=it
          w1=stodata(w1)
        end if
        macsi(w1,me,1)
        w1=""
        addme : continue do
      end if
      '
      poff=aoff
      '
      '
      '
      '#######  #############
      'ARRAYS   #  #  #  #  #
      '#######  #############
      '         #  #  #  #  #
      '         #############
      '         #  #  #  #  #
      '         #############
      '
      '
      '
      'CHECK FOR ARRAY TYPE
      '
      if arv then
        inserts(s,ary,i) 'itr array of arrays not supported
      end if
      '
      '======
      'ARRAYS
      '======
      '
      skiplspace(s,i)
      '
      if (ascn=lbr)or(ascn=91) then
        '
        i+=1 : skiplspace(s,i) : v=w
        '
        '
        if (ascn=rbr)or(ascn=93) then
          i+=1 : skiplspace(s,i) : m=1 : goto narray
        end if
        '
        m=metaval(s,i,w1)-ixb+1
        maco(me,4)=m 'number of elements specified
        v*=m
        '
        if ascn=44 then
          ers="Single dimension only" : ert=444 : exit sub
        elseif (ascn=rbr)or(ascn=93) then
          i+=1 : skiplspace(s,i) 'skip right bracket
        end if
      end if
      '
      '======
      narray:
      '======
      '
      if c then v=cpuw 'pointer to variable or array
      '
      'ALIGN SIZE TO 4 OR 8 BYTES
      '--------------------------
      '
      a=cpuw-1
      if v<cpuw then v=cpuw
      if v>cpuw then v=(v+a) and &h7fffffff-a
      '
      'STEP UP OR DOWN
      '---------------
      '
      'ASSIGN
      '
      if vstp then v=vstp 'FORCE STEP SIZE
      '
      if asce=1 then aoff+=v : a=poff else aoff-=v : a=aoff
      '
      maco(me,2)=a   ' offset
      macsi(memreg(regs,a),me,1)
      macsi(wd,me,2)  
      '
      '=======================
      'REGISTERS / VAR LINKAGE
      '=======================
      '
      '
      if ascn=97 then
        if wordahead(s,i)="at" then
          i=nwd
          b=0
          '
          do
            wr=tword(s,i)
            if (ascw=38)or(ascw=64) then b-=1 : continue do 'address 
            if ascw=42 then b+=1 : continue do 'indirection
            exit do
          loop
          '
          maco(me,3)+=b 'INDIRECT ARRAY RESOLUTION
         '
          a=ascw : v=0
          '
          if a=91 then
            i=swd : wr=mword(s,i) 'REG / MEM OPERAND
          elseif a>96 then
            c=lookupm(wr)
            if c then
              b=maco(c,0)
              '
              'CHECK IF VARIABLE IS TO BE A REGISTER
              '
              if b=-10 then
                '
              else
                maco(me,3)+=1 'POINTER VARIABLE: ADD INDIRECTION
                wr=macso(c,1)
                v=maco(c,2)
              end if
            end if
          elseif a=35 then
            wr="["+wr+"]" 'HOST VAR ADDRESS #VAR
          end if
          '
          macsi(wr,me,1)
          '
          aoff=poff ' no change to offset
          maco(me,2)=v
        end if
      end if
      addme
    loop
    if wordahead(s,i)="var" then mc=0 : goto varss 'FURTHER VAR STATEMENTS
    if lclv=0 then aoffs=aoff
end sub



'-----------------------------------------------------------------
sub varsal(byref s as string, byref i as sys, byval noinit as sys)
'=================================================================
  dim as sys a
  if o2h then
    if funi then localvars() : lcl(funi)=1 else staticvars()
    a=aoff : vars(s,i) : a-=aoff
    '
    'ALLOCATE SPACE ON STACK FOR LOCAL VARIABLES
    '-------------------------------------------
    '
    if a>0 then appendt(stackspace(a,noinit))
  else
     vars(s,i)
  end if
end sub



'---------------------------------------------------------------------------------------
sub declvars(byref s as string, byval n as sys, byref wa as string, byval noinit as sys)
'=======================================================================================
  dim as sys a,b
  '
  if n<10 then
    '
    if n=1 then
      localvars()
    elseif (n=3)or(n=4) then
      staticvars()
    end if
    '
    'SETTING A CONSTANT
    '
    if cnst then
      vars(tword(s,1)+" "+wa,1)
      wa=""
      exit sub
    end if
    '
    a=aoff : vars(s+"",1) : a-=aoff
    '
    if n=1 then
      if a>0 then
        if (noinit<>0)or(ccp(funi)=16) then
          if isstr(maco(me-1,5))=0 then b=1
        end if
        wa=stackspace(a,b)+wa
      end if
    end if
    '
  else 'n>=10
    if n<>18 then wva(n)+="var "+s+cr 'PARAMS DEFERRED
  end if
  '
end sub



'-----------------------------------
sub vtlcheckmark(byref wr as string)
'===================================
  dim as sys a
  a=instr(wr,"/\")
  if a then
    a+=2
    if asc(wr,a)<>13 then
      wr=left(wr,a-1)+cr+mid(wr,a)
    end if
  end if
end sub


'#                 #
'###################
'###    TYPES    ###
'###################
'##     #####     ##
'       #####
'       #####
'       #####     ##    ##     ######       #####
'       #####     ##    ##     ##    ##   ##     #
'       #####     ##    ##     ##    ##   ########
'       #####      #######     ######     ##
'       #####           ##     ##         ##     #
'       #####           ##     ##          ######
'      #######     #####

' aml   array size multiplier
' buil  table builder string
' wih   inherited elements to pre-append 
' wmx   max structure length for unions
' vtl   virtual data flag
' po    offset value building def
' pk     k holder
' vo    next offset value building def
' vp    hold offset for inherited strucs

'---------------------------
sub types(byval unip as sys)
'===========================



  '=====================================
  'macso:
  '=====================================
  '0 name
  '1 structure
  '2 reserved for methods block
  '3 virtual table maker script
  '=====================================
  'maco:
  '=====================================
  '0 metatype (-3)
  '1 object length
  '2 offset
  '3 flag to indicate vtp field present
  '4 virtual table entries
  '5 
  '=====================================



  dim as sys   a,b,c,d,e,f,g,k,m,n,v,w
  dim as sys aml,ctbl,pk,vo,vtl,sih,po,wmx,pp,unif(7),unio(7),unim(7),uni,bb,cmo,indi,sni,clas,sta

  dim as string prf,w1,w2,w3,w4,w5,wd,wm,wn,wr,ws,wt,buil,wih,unin(7),tbls,wpr,nesn

    maco(me,0)=-3 ' is a type

    wm=" "+macso(me,1)+" " : k=1
    'w     ' offset accumulator
    'wmx   ' max offset accumulator (unions)
    'po : vo : ctbl
    '
    '
    '
    vtl=instr(wm,"/\"+cr)
    '
    if vtl>0 then
      a=maco(me,2) and 2
      if a=0 then ctbl=1 'VIRTUAL TABLE IS PRESENT
      'ctbl=1
    end if
    '
    cmo=unip and 8   'C MODE FLAG
    clas=unip and 16 'class flag
    '
    'CHECK FOR UNION (1) OR TYPE (0)
    '-------------------------------
    '
    a=unip and 1
    unif(uni)=a
    unim(uni)=a

    sih=0
    addme()
    '
    '=======================
    do 'FOR EACH MAIN MEMBER
    '=======================
      '
      maindec:
      '
      pk=k
      '
      'SKIP COMMAS
      'SKIP 'HAS' etc
      '
      'READ QUALIFIER WORDS
      '--------------------
      '
      sta=0
      '
      do
        wr=tword(wm,k)
        '
        if ascw=35 then
          '
          'EXTRACT ANY #DEFINES
          '--------------------
          '
          if wr="#define" then
            do
              m=swd
              endline(wm,k)
              w1=rtrim(mid(wm,m,k-m))
              k+=2 : wm=left(wm,m-1)+mid(wm,k) : k=m
              defbuf+=w1+cr
              if asc(w1,len(w1))<>92 then exit do 'checking for line continuation '\'
            loop
          end if
          continue do 'main loop
        end if
        '
        b=dic(" of 2, from 2, has 1, inherits 2, static 3, align 8, ",wr)
        select case b
        case 0 : exit do
        case 2 : sih=1 : vtp or=1
        case 3 : sta=1
        case 8 
          b=swd : wr=tword(wm,k) : v=-wval(wr) : a=w and v 
          if a<w then w=a-v
        end select
        mid$(wm,swd)=space(lenw)
      loop
      '
      a=ascw
      '
      'OVERRIDE PREVIOUS ELEMENTS OF SAME NAME
      '---------------------------------------
      '
      'override methods by appending new methods
  
      '---------------------
      'CHECK FOR END OF BODY
      '=====================
      '
      if wr="" then exit do 'END OF STRUCTURE
      '
      '------------------------
      'CHECK FOR METASTATEMENTS
      '========================
      '
      if a=35 then
        c=swd : wr=mword(wr,1) : swd=c
        if mc=-13 then
          md=maco(mp,3)
          if md>=100 then
            metaco(wm,k)
            continue do
          end if
        end if
      end if
      '
      '--------------------------
      'END OF VIRTUAL FUNCTIONS /
      '==========================
      '
      if a=47 then
        '
        if vtl=0 then continue do 'IGNORE ALL BUT THE FIRST '/' ENCOUNTERED
        '
        k+=1 : skiplspace(wm,k) ' /\
        '
        ' ASSIGN VIRTUAL TABLE ENTRIES AND CLEARDOWN
        '
        maco(me-1,4)=w/cpuw : w=0 : wmx=0 : po=0 : vo=0 : vtl=0
        '
        if ascn=0 then wm+=cr 'ensure ending with cr for proper line ending
        k+=2                  'skip cr following
        '
        'IS A VIRTUAL TABLE POINTER NEEDED?
        '----------------------------------
        '                   
        if (vtp>0)and(sih=0) then
          '
          'INSERT VTP PLACE
          '
          wm=left(wm,k-1)+htb+"_i_ 0 1 A0 , sys"+cr+mid(wm,k) : k+=19
          w=cpuw : po=w
          '
        end if
        '
        pk=k
        '
        'INHERITED BODY LIST
        '-------------------
        '
        'insert the accumulated subelements
        '
        if len(wih) then
          ws=wih : wih="" : wd=","
          '
          'SPLIT THE STRUCTURE STRING
          '
          wt=" "+mid(wm,pk) : wm=left(wm,pk-1)
          '
          goto insert_subelements
          '
        else
          continue do
        end if
        '
      end if 'end of virtual functions /


      '
      '---------------------------
      'UNIONS AND INNER STRUCTURES
      '===========================
      '
      if unif(uni) then
        '
        'CHECK WITHIN UNION
        '------------------
        '
        if unim(uni) then
          if w>wmx then wmx=w ' MAX VAR OFFSET+SIZE
          w=unio(uni)         'RESTORE OFFSET
        end if
        '
        '
        'CHECK END OF UNION/STRUCT
        '-------------------------
        '
        b=swd
        if unif(uni)=1 then
          if wr="end" then
            if instrword(" union struct ",wordahead(wm,k)) then
              k=nwd : unif(uni)=a
            end if
          end if
        end if
        '
        ' ) } OR END OF UNION/STRUCT
        '---------------------------
        '
        if a=unif(uni) then
          '
          if unim(uni) then
            if w<wmx then w=wmx 'MAX VAR OFFSET+SIZE  IN UNION
          end if
          '
          'SWALLOW WORDS FOLLOWING STRUC/UNION
          '
          do
            if ise(ascn) then exit do else w1=tword(wm,k)
          loop
          '
          uni-=1
          mid(wm,b)=space(k-b) 'WIPE
          continue do
        end if
        '
      end if
      '
      'CHECK FOR START OF NESTED UNION / STRUCT
      '----------------------------------------
      '
      d=dic(" struct 1, union 2, type 1,",wr)
      '
      if d then
        uni+=1
'if d=2 then roundup(w,4) 'UNION ALIGN
        unio(uni)=w : unif(uni)=1 : unim(uni)=d-1 : b=swd
        if isx(ascn) then
          a=k : nextinstruct(wm,k)
          if (ascn<>lbr)and(ascn<>123) then k=a : goto nuname 'brackets not used here
        end if
        if (ascn=lbr)or(ascn=123) then
          'ANONYMOUS
        else
          unin(uni)=tword(wm,k)+"." : nextinstruct(wm,k) 'NAME GIVEN
        end if
        '
        '------
        nuname:
        '------
        '
        c=0 : d=1
        '
        if ascn=lbr then d=rbr : k+=1 '(
        if ascn=123 then d=125 : k+=1 '{
        unif(uni)=d
        '
        'CHECK FOR ASSOCIATED STRUC NAME
        '
        if d=125 then
          c=k-1 : capture(wm,m,c,0) : skiplspace(wm,c)
          if ise(ascn)=0 then unin(uni)=tword(wm,c)+"." 'capture 1st associated name
        end if
        '
        mid(wm,b)=space(k-b) 'WIPE
        continue do
        '
      elseif a=61 then
        '
        'UNION START MARKER '='
        '
        if w>wmx then wmx=w 'SET UNION MAX SIZE
        w=0 'RESET OFFSET
        mid(wm,swd)=" " 'WIPE
        continue do
        '
      end if 'UNIONS AND INNER STRUCTURES
      '
      '================================
      'TRANSFORM BASIC SYNTAX TO OXYGEN
      'REARRANGE ELEMENT DECLARATION:
      '==============================
      '
      'OVERVIEW:
      '=========
      '
      'C STYLE
      '
      '---------------------------------------------------------------
      ' TYPE/RETURN | NAME | ARRAY OR METHOD/FUNCTION/SUB | (PARAMS) | 
      '===============================================================
      '
      '
      'BASIC
      '
      '-------------------------------------------------------------------
      ' NAME AS | TYPE OR METHOD/FUNCTION/SUB | (PARAMS) | AS RETURN_TYPE |
      '===================================================================
      '
      'TO:
      '===
      '
      '----------------------------------------------------------
      ' TYPE | NAME | METHOD_FLAG: ! | (PARAMS) | AS RETURN_TYPE |
      '==========================================================
      '
      '
      'DECLARE 1 DIM 2 vword
      '---------------------
      '
      dcl=0 : priv=pp
      '
      vword(wm,k,wr)
      '
      if wr="" then
        pp=priv : continue do ' APPLIES TO SEVERAL MEMBERS
      end if
      '
      b=swd : n=0 : ascw=0 : indi=0
      w1=wordahead(wm,k)
      w2="" : w3=""
      a=asc(w1)
      '
      'NESTED VARIABLES (NAME DOT)
      '
      if a=123 then
        w2=htb+nesn+wr+" "+str(w)+" 0 0 0 0 0"+cr
        nesn+=wr+"."
        wm=left(wm,swd-1)+w2+mid(wm,nwd)
        k=swd+len(w2)
        continue do
      end if
      '
      if asc(wr)=125 then
        a=len(nesn)-1
        do
          a-=1 : if a<=1 then nesn="" : exit do
          if asc(nesn,a)=46 then nesn=left(nesn,a) : exit do
        loop
        mid(wm,swd)=" " : continue do
      end if
      '
      'CHECK FOR CALLING CONVENTION
      '
      cco=ccx 'always the prevailing default
      '
      '---------------------------
      'SUB FUNCTION METHOD name ..
      '===========================
      '
      mth=dic(" ! 03, sub 01, function 02, method 03, ",wr)
      '
      if mth then
        mid(wm,swd)=space(k-swd) 'BLANK
        k=nwd
        a=identype(w1)
        if a then wr=w1 : goto typebfna 'TYPE BEFORE NAME
        '
        w2=w1
        n=&h11f
        wr="sys"
        a=k 'HOLDING POSITION FOR LOOKAHEAD
        w1=tword(wm,k)
        if ascw=lbr then k=a : goto pparams else w3="()"  'CREATE EMPTY '()'
        '
        'CHECK FOR RETURN TYPE
        '---------------------
        '
        if w1="as" then
          a=1 : goto astype
        else
          k=a 'backtrack
          ascw=0 : skiplspace(wm,k) : goto reagg 'NO RETURN TYPE
        end if
        '
      end if 'procedures
      '
      w2=wr 'assume
      '
      'DECLARE name AS TYPE
      '--------------------
      '
      if w1="as" then
        k=nwd : n=1 : a=1 : goto astype
      end if
      '
      if isx(ascn)=0 then
        a=identype(wr)
      else
        a=0
      end if
      '
      '
      '=========
      typebfna: 'TYPE BEFORE NAME (C STYLE)
      '=========
      '
      '
      if (a<>0)and(a<&h100)or(a>=512) then
        typ=a : m=0
        do
          if ascn=lbr then
            exit do 'procedure name in brackets
          end if
          w2=tword(wm,k)
          if ascn=lbr then if mth=0 then if clas then mth=3
          if ascw=42 then m+=1 : continue do
          if w2="ptr" then m+=1 : continue do
          exit do
        loop
        n=1
        if m then w2=string(m,"*")+w2
        '
        a=0
        '
        'CHECK FOR PROCEDURES OR ARRAYS
        '------------------------------
        '
        if ascn=lbr then
          '
          if mth<>3 then    'except for methods
            '
            'FORMAT long* (*fun) (long x)
            '
            mth=4
            if m then
              a=1
              if m=1 then
                if (typ>&ha0)and(typ<&hc0) then
                  wr=revdic(idtype,typ)
                  a=0 'chars and zstring ptr
                end if
              end if
              if typ>512 then
                a=0 'implict pointer for higher types
              end if
              a=0
              if a then wr="sys"
            end if
            k+=1            'skip left bracket
            w2=tword(wm,k)   'get next word
            if w2="*" then  '
              w2=tword(wm,k) '
            end if          '
            k+=1            'skip right bracket
          end if
          a=1 : n=&h11f     'PROCEDURE
          '
        elseif ascn=91 then
          '
          a=1 : n=2       'ARRAY
          '
        end if
        '
        'check ahead for opening parameter bracket
        '-----------------------------------------
        '
        if a then w1=wordahead(wm,k)
        '
      end if
      '
      '
      '--------------------------------------------
      pparams:   '(..) [] ARRAY OR PROCEDURE PARAMS
      '============================================
      '
      if (w1="(")or(w1="[") then
        capture(wm,m,k,a)
        w3=mid(wm,m,k-m)
        w1=wordahead(wm,k)
        if n=0 then n=1
        if w1="as" then
          k=nwd
        else
          if n<2 then wr="sys"
        end if
      end if
      '
      '
      '--------------------------------
      astype:  'AS dim type or fun type
      '================================
      '
      if w1="as" then a=1 else a=0
      '
      if a then
        wr=tword(wm,k)
        do
          w1=wordahead(wm,k)
          if instrword(" * ptr ",w1) then k=nwd : indi+=1 : skiplspace(wm,k) else exit do
        loop
        vword(wm,k,wr)
        if ascn=44 then k+=1 'skip comma
      end if
      '
      '
      '----------------------
      'REARRANGE TO O2 SYNTAX
      '======================
      '
      'wr primary type: method or vartype
      'w2 name
      'w3 parameters (..)
      '
      '
      '
      '----------------------------------------
      reagg: 'PUT THE DECLARATION BACK TOGETHER
      '========================================
      '
      '
      if n then
        '
        'INSERT TYPE NAME AS TYPE 
        '
        wm=left(wm,b-1)+wr+" "+w2+" "+w3+cr+mid(wm,k)
        swd=b
        k=b+len(wr)+1
        '
      end if
      '
      bb=swd-1 ' LOCATION OF TRIMBACK POINT
      '
      '
      'IS IT THE DEFAULT TYPE OR
      'IS THE TYPE SPECIFIED BY SIZE?
      '------------------------------
      '
      if mth>0 then v=cpuw else v=wval(wr)
      '
      lent=v and 31
      '
      'OTHERWISE TRY TO IDENTIFY THE TYPE
      '
      
      if v=0 then
        '
        n=identype(wr)
        '
        if (n<0)or(n=&h20) then
          '
          'LOOKS LIKE A C TYPE EXPRESSION
          '------------------------------
          '
          ctype(wm,k,wr)
          if wr="void" then typ=cpuw : lent=cpuw 'IN THIS CONTEXT
          v=lent : n=typ ': mid(wm,b)=space(k-b)
          '
        elseif n<512 then
          '
          'A PRIMITIVE TYPE OR PART OF MULTIELEMENT
          '----------------------------------------
          '
          if n=0 then
            '
            'LOOKAHEAD FOR MULTI-ELEMENT 'AS'
            '
            c=swd
            a=k
            endline(wm,a)
            b=instr(k,wm," as ")
            if (b>0)and(b<a) then
              w1=tword(wm,b+4)
              n=identype(w1)
              mid(wm,b)=space(a-b) 'blank
              if n then wr=w1 : k=c
            end if
            '
            'ASSUME UNIDENTIFIED TYPE TO BE SYSTEM TYPE
            '
            if n=0 then
              'n=cpuw : lent=cpuw
              'k=c : wr="sys" 'LONG OR QUAD
              ert=121 : ers="Unidentified element type" : ow=wr : exit sub
            end if
          end if 
          v=lent
          '
        else 'n>=512
          '
          'CHECK IF POINTER TO ANOTHER STRUCTURE
          '-------------------------------------
          '
          '
          '
        end if
        '
        if asc(w2)=42 then indt+=1 : k+=1 'indt initially set by identype
        indt+=indi 'indi is ptr flag
        if indt then v=cpuw
      end if
      '
      '
      '
      '========================
      multielement: 'PRIMITIVE
      '========================
      '
      '
      '
      'PRIMITIVE ELEMENTS AND PROCEDURES
      '---------------------------------
      '
      aml=1 'DEFAULT AS 1 ARRAY ELEMENT
      '
      if v>0 then
        '
        '
        'AUTO-ADJUST BOUNDARY ALIGNMENT (PADDING)
        '----------------------------------------
        '
        if pakd=0 then roundup(w,v) 'itr unions
        '
        a=swd : wn=nesn+unin(uni)+tword(wm,k)
        '
        c=ascn
        '
        '
        'ALLOCATE SPACE FOR STATIC ARRAY
        '-------------------------------
        '
        if mth=0 then
          if (c=lbr)or(c=91) then
            a=k : aml=arraysize(wm,k)
          end if
        end if
        '
        '
        'COMPOSE ELEMENT DESCRIPTOR
        '--------------------------
        '
        c=bref
        if cmo then bref=0 'NO AUTO BYREF IN C MODE
        '
        wt=str(w)+encodele(wm,wr,k,n,vtl,ws)
        bref=c
        '
        '
        'ADD INSTRUCTION TO VIRTUAL TABLE BUILDER
        '----------------------------------------
        '
        if ctbl then
          if (vtl>0)and(mth>0) then
            ws=splitsi(ws,"")
            VTEntry(buil, wn, ws, w)
          end if
        end if
        '
        '
        'INSERT COMPOSED DESCRIPTOR
        '--------------------------
        '
        wpr+=htb+wn+" "+wt+cr : skipspace(wm,k)
        '
        '
        'ADD OFFSET FOR NEXT ELEMENT
        '---------------------------
        '
        w+=v*aml
        '
        '
        'MULTI ELEMENT / PROPERTY
        '------------------------
        '
        'MEMBERS DEFINED TOGETHER EG: SYS A,B,C(10),D
        'this syntax should not be used for methods.
        '
        '
        if ascn=44 then
          k+=1 : nextinstruct(wm,k)
          '
          'SUPPORT INDIRECTION
          '
          if ascn=42 then
            a=1 : k+=1 : skiplspace(wm,k)
          else 
            a=0
          end if
          swd=k : ascn=0
          if identype(wordahead(wm,k))=0 then
            indt=a : goto multielement 'REPEAT FOR NEXT ELEMENT
          end if
        end if
        '
        '
        'OTHERWISE NO FURTHER ELEMENTS IN THIS (COMMA CHAINED) LIST
        '
        'TRIM OFF PROCESSED SCRIPT AND RECOMPOSE BLOCK
        '---------------------------------------------
        '
        w2=rtrim(left(wm,bb))+wpr : wpr="" 
        wm=w2+mid(wm,k) ' reconstruct
        k=len(w2)+1   'SOURCE READER OFFSET
        '
        ' itr space allocated for static arrays
        ' but multidimens not specified (ubound inferred from offs)
        '
        'PROCESS NEXT ELEMENT
        '--------------------
        '
        continue do
        '
      end if 'PRIMITIVES (V>0)
      '
      '#########
      'INHERITED
      '#########
      '  #####
      '  #####
      '  #####
      '  #####
      '  #####
      '  #####
      '  #####
      '  #####
      '  #####
      '  #####
      '#########
      '#########
      '#########
      '
      '
      'GET ELEMENT NAME (OR COMMA FOR INHERITED ELEMENTS)
      '
      sni=n 'inherited type
      '
      '--------------------------------------------------------------
      rmultisubstruct: 'loop point for instances of inherited members
      '==============================================================
      '
      aml=1
      '
      skiplspace(wm,k)
      if ise(ascn) then
        wd=","
      else
        wd=tword(wm,k)
      end if
      '
      '
      'CHECK FOR ARRAY DEFINITION
      '--------------------------
      '
      'LOOK FOR ROUND OR SQUARE BRACKETS
      '
      if (ascn=lbr)or(ascn=91) then
        aml=arraysize(wm,k) : 'ARRAY SIZE
      end if
      '
      if ascn=97 then
        if wordahead(wm,k)="as" then
          k=nwd : w1=wrd(wm,k) ' swallow as ..
        end if
      end if
      '
      a=sni-512 'STRUCTURE INDEX
      '
      if a>0 then e=1 else e=0
      if e=0 then ers="Undefined "+wr : ert=10 : exit sub
      '
      ws=macso(a,1)
      '
      m=instr(ws,"/\"+cr)
      '
      if vtl=0 then
        '
        if m then
          ws=mid(ws,m+2) 'OMIT VIRTUAL SECTION IF PARENT IS NOT A CLASS
        end if
        '
      else 'vtl<>0
        '
        if m=0 then
          '
          'STA STATIC ELEMENT STAYS IN VIRTUAL SECTION
          '
          if sta=0 then
            ws="/\"+cr+ws 'NO VIRTUAL SECTION DEFINED
          end if
        else 'm<>0
          if maco(a,4) then
            if ctbl then tbls+=addtablesection(wr,w,a,aoff) : if lclv=0 then aoffs=aoff
          end if
        end if
        '
      end if
      '
      '
      '--------------------------
      'SPLIT THE STRUCTURE STRING
      '==========================
      '
      wt=" "+mid(wm,k)
      wm=left(wm,pk-1)
      '
      '
      'INCORPORATE INHERITED BODY ELEMENT
      '
      if wd<>"," then
        if priv=0 then priv=&h39 '9' public
        c=0
        if vtl+m+sta=0 then c=1 : w4=" 1 "
        if m+sta>0 then c=2 : w4=" 2 "
        if c then wm+=htb+nesn+wd+" "+str(w)+w4+chr(priv)+" A , "+macso(a,0)+cr
      end if
      '
      'CALC OFFSET FOR NEXT INHERITED COMPONENT. (ARRAY SPACE INCLUDED)
      '
      'calculated in advance
      '
      po=w : c=0
      '
      if vtl then
        if m then
          c=4
        elseif sta then
          c=1
        end if
      else 'vtl=0
        if sta+m=0 then
          c=1
        end if
      end if
      '
      if c=1 then
        po=w+maco(a,1)*aml 'body part
      elseif c=4 then
        po=w+maco(a,4)*aml*cpuw 'virtual part
      end if
      '
      '
      '==================
      insert_subelements:
      '==================
      '
      '---------------------------
      'PROCESS INHERITED ELEMENTS
      '--------------------------
      '
      b=1
      '
      '
      do 'FOR EACH OF THE INHERITED ELEMENTS
        '
        wn=tword(ws,b) 'THE NAME OF THE SUB ELEMENT
        '
        if wn="" then exit do
        m=ascw
        '
        '
        '---------------------------------
        'CAPTURE BODY OF INHERITED ELEMENT
        '=================================
        '
        if m=47 then 
          '
          'end of vt section and start of object body
          '
          '
          if vtl>0 then
            '
            'CAPTURE BODY OF INHERITED COMPONENT
            '-----------------------------------
            '
            vo+=maco(a,1)*aml  'accum size of objects
            '
            'CHECK FIRST IF THERE ARE ANY ELEMENTS IN THE BODY
            '-------------------------------------------------
            '
            b+=1 : nextinstruct(ws,b) '/\
            '
            if len(ws)>=b then
              wih+=" ?"+str(a)+" "+str(aml)+" "+wd+" "+mid(ws,b)
            end if
            '
          end if
          '
          ws="" : exit do ' captured body section
          '
          'previously held over for the body section
          'It is assumed that we are in in the parantal body section.
          '
        elseif m=63 then 
          '
          'INSERT BODY OF INHERITED SUBELEMENTS INTO MAIN BODY ('?' MARKER)
          '----------------------------------------------------------------
          '
          a=wval(tword(ws,b))   'index
          aml=wval(tword(ws,b)) 'array / single scale
          wd=tword(ws,b)        'type/inherited structure
          wn=tword(ws,b)        'name
          '
          'BODY OFFSET (allowing for static arrays )
          '
          w=po : po+=maco(a,1)*aml
          '
          '
          'INCORPORATE INHERITED STRUCTURE NAME
          '
          '
          'A HEADER IS ADDED DESCRIBING THE WHOLE INHERITED STRUCTURE
          '
          if wd<>"," then
            '
            'another of these may be present in the virtual section.
            if priv=0 then priv=&h39 '9' public
            wm+=htb+nesn+wd+" "+str(w)+" 1 "+chr(priv)+ " A , "+macso(a,0)+cr
          end if
          '
        end if 'm=63 '?'
        '
        'READ ATTRIBUTES OF EACH INHERITED ELEMENT
        'Recalculate offsets make other adjustments.
        'This applies to both virtual and body sections.
        '
        v=wval(tword(ws,b)) ' OFFSET
        w4=tword(ws,b)      ' VAR/FUNCTION CODE (VARF)
        prf=tword(ws,b)     ' PUBLIC/PROTECTED/PRIVATE
        '
        'CAPTURE REST OF ATTRIBUTES: CCO VDV SIG SOG PRIV
        '
        c=b : endline(ws,b)
        w5=mid(ws,c,b-c) ' PARAM SIGNATURES
        '
        'ADJUST VAR/FUNCTION CODE VARF
        '-----------------------------
        '
        if vtl then 
          n=wval(w4) ' varf
          m=n
          if (n=2)or(n=4) then
            wn="__" 'BLANK NAME 'inherited statics are private (due to mapping)
          end if
          if sta then
            if (n=1)or(n=3) then n+=1  'RENDER STATIC (eg types declared static)
          end if
          '
          if sih=0 then
            if n=9 then n=10 'SIGNIFIES INHERITED METHOD
            if n>=10 then
              n+=vo
              if vtp then n+=cpuw 'FURTHER OFFSET IF VTP IS PRESENT
            end if
          end if
          '
          if n<>m then w4=str(n) 'CONVERT BACK TO STRING
          '
        end if
        '
        'PRIVATE FLAG
        '
        if prf="0" then
          wn="__" ' disinherit name
        end if
        '
        'PREFIX NAME DOT TO GIVE THE LOCAL NAME
        '
        if wd<>"," then
          wn=wd+"."+wn 'IF WD IS A COMMA THEN USE THE ORIGINAL NAME
        else
          wn=nesn+wn
        end if
        '
        '
        'APPEND RECONSTITUTED DESCRIPTOR
        '-------------------------------
        '
        'start with tab
        '
        'add element with adjusted offset
        '
        wm+=htb+unin(uni)+nesn+wn+" "+str(v+w)+" "+w4+" "+prf+" "+w5+cr
        '
        '
      loop ' EACH INHERITED SUB ELEMENT
      '
      '
      w=po        'UPDATE OFFSET FOR VFT OR BODY
      k=len(wm)+2 'NEXT LINE TO PROCESS
      pk=k
      '
      'REASSEMBLE MAIN STRUC STRING
      '
      wm+=wt
      '
      'MORE NAMES TO FOLLOW?
      '---------------------
      '
      nextinstruct(wm,k)
      '
      'check for comma
      '
      if ascn=44 then
        k+=1 : goto rmultisubstruct 'loop back to process similar members
      end if
      '
    '===================================
    loop 'EACH ELEMENT IN MAIN STRUCTURE
    '===================================
    '
    '
    '------------------------------
    'STORE COMPLETED DATA STRUCTURE
    '==============================
    '
    b=me-1
    '
    maco(b,3)=vtp
    '
    macsi(wm,b,1)
    if wmx>w then w=wmx            'MAX SIZE FOR UNIONS
    'if pakd=0 then roundup(w,cpuw)    'ROUNDUP SIZE TO NEAREST 4/8? BYTE BOUNDARY
    maco(b,1)=w                    'LENGTH OF STRUCTURE
    '
    '
    'SOURCE LISTING
    '
    if vew>0 then
      appendt(cr+"skip"+sp+"TYPE: "+macso(b,0)+cr+cr+macso(b,1)+cr+"END TYPE"+ep) : bg=j
    end if
    '
    '---------------------
    'VIRTUAL TABLE BUILDER
    '=====================
    '
    if ctbl then
      '
      'INFER BASE ADDRESS OF VFT
      '
      c=maco(b,4) : a=aoff
      '
      if asce<0 then a-=c*cpuw 'MAY BE LOCAL OR STATIC
      '
      'VFT BUILDER TO GO AT BOTTOM OF METHODS BLOCK
      '
      if len(buil) then
        buil="lea "+qecx+cm+memreg(regs,a)+cr+buil+cr
      end if
      '
      macsi(tbls+buil,b,3)
      '
      'DECLARE THE VACANT VIRTUAL FUNCTION TABLE IMMEDIATELY AFTER CLASS
      '
      w1="sys "+macso(b,0)+"_table("+str(c)+")"
      varsal(w1,1,0)
      '
      '
    end if
    '
end sub




'--------------------------------------------------
sub CaptProcHead(byref wr as string,byref b as sys)
'==================================================
  dim as long a,c
  dim as string w1
  '
  do
    skiplspace(wr,b)
    if ise(ascn) then
      c=b : nextinstruct(wr,b)
      if ascn<>lbr then b=c : exit do
    end if
    if (ascn=123)or(ascn=61)or(ascn=sr1) then exit do 'FUNCTION .. {}   FUNCTION .. =
    if (ascn=lbr) then
      if a then exit do 'assume start of body
      capturi(wr,1,1,b)
      a=1
      continue do
    end if
    w1=tword(wr,b) 'EAT FINAL WORD
  loop
end sub


'---------------------------------------------------------------------------------------
sub CaptProcBody(byref w1 as string,byref wr as string , byref b as sys, byref d as sys)
'=======================================================================================
  dim as sys a,f
  dim as string w2
  '
  d=0
  f=b
  '
  'LOOKAHEAD FOR BODY CONTAINED BY () {..}
  '---------------------------------------
  '
  a=b : nextinstruct(wr,a)
  '
  if (ascn=lbr)or(ascn=123)or(ascn=61) then
    capturi(wr,1,1,a) : endline(wr,a) : d=a+2
    exit sub
  end if
  '
  'SPECIAL BLOCK CAPTURE
  '---------------------
  '
  do
    w2=tword(wr,f)
    '
    if w2="" then
      exit do
    elseif w2=w1 then
      if (ascn>96)and(ascn<123)and(instrword(" and or xor ",wordahead(wr,f))=0) then
        if w2="method" then exit do : 'NEW METHOD FOUND SO ASSUME THIS ONE IS ONLY A HEADER
        'OTHERWISE:
        'FUNCTION INSIDE A FUNCTION ETC
        'FUNCTION/METHOD ASSIGNMENT
      end if
    elseif w2="exit" then
      w2=wword(wr,f) 'SKIP
    elseif w2="end" then
      w2=tword(wr,f)
      if w2="" then exit do
      if w1=w2 then endline(wr,f) : f+=2 : d=f : exit do 'CONFIRMED BODY NOT JUST HEADER
    elseif ascw=35 then 
      if left(w2,3)="#if" then metaskip(wr,f,2) 'METABLOCK
    elseif (ascw=lbr)or(ascw=123) then
      f=swd : capturi(wr,1,1,f) 'SKIP (..) {..}
    elseif isc(ascw) then
      endline(wr,f)
    end if
    '
  loop
  '
end sub
 


'-------------------------------------------------------------------------------------------
sub makeheaders(byref wr as string, byref w4 as string, byref w3 as string, byval mo as sys)
'===========================================================================================
  '
  ' mo=1 #lookahead declarations
  ' mo=2 extraxt class header
  '
  dim as sys a,b,c,d,e,f,m
  dim as string w1,w2,w5,w6,wm,lns
  b=1 : wm=wr : w3="" : w4="" : e=b
  '
  '
  '------------------------
  'SCAN THROUGH CLASS BLOCK
  '------------------------
  '
  'SEPARATE CLASS HEADERS FROM METHOD BODIES
  '
  do
    '
    skiplspace(wr,b)
    if ascn=0 then exit do
    if ascn<=13 then a=1 else a=0
    w1=tword(wr,b)
    '
    '
    if ascw=rbr then exit do 'INSIDE A SCOPE
    '
    '
    'COMMENTS
    '--------
    '
    if isc(ascw) then
      d=swd : endline(wr,b)
      if ascn=lnm then
        lns=mid(wr,d,b-d+2) 'prior line number
      end if
      '
      'INCLUDE WHOLE-LINE COMMENT IN METHODS BLOCK (OMIT FROM CLASS DEF)
      '
      if a then
        b+=2
        if mo=2 then
          w3+=mid(wr,d,b-d)
          mid(wr,d)=space(b-d)
        end if
        skiplspace(wr,b) : e=b
      end if
      '
      continue do
    end if
    '
    '
    'SKIP QUALIFIER WORDS
    '--------------------
    '
    if mo=1 then
      if instrword(" leaf ",w1) then
        w1=tword(wr,b)
      end if
    end if
    '
    '
    if mo=2 then

      if ascw=47 then
        if ascn=92 then '/\
           wr=wm : w3="" : w4="" : exit do  'RESTORE ORIGINAL : (SEPARATE METHODS BLOCK OR EXTERNAL)
        end if
      end if


      if a then e=swd ' start of new line
      if ascn=61 then goto classign
      '
      'INHERIT OR MACRO EXPANSION
      '--------------------------
      '
      if identype(w1)>512 then
        a=1
      elseif instrword(" static of has from incl inherits ",w1) then
        if expandm(wr,b) then
          wm=wr : continue do 'EXPANDED MACRO
        end if
        a=1
      else
        a=0
      end if
      '
      if a then
        '
        'CAPTURE IN TOP SECTION (FOR LATER SPLITTING INTO VIRTUAL AND BODY)
        '
        endline(wr,b) : b+=2
        w4+=mid(wr,e,b-e)
        mid(wr,e)=space(b-e) 'blankout
        e=b
        continue do
      end if
      '
      'DUAL QUALIFIER WORDS
      '--------------------
      '
      if instrword(" public private protected leaf ",w1) then
        a=0
        if ise(ascn) then
          endline(wr,b) : b+=2
          a=1
        else
          w2=wordahead(wr,b)
          if instrword(" method static ",w2) then a=1
          'itr leaf method?
        end if
        if a then w4+=mid(wr,e,b-e)
        e=b
        continue do 'parsing
      end if
      '
      a=ascn
      '
      if ise(a) then
        m=b
        nextinstruct(wr,m) : a=asc(wr,m)
        if a=123 then b=m
        skiplspace(wr,b)
      end if
      '
      'NESTED TYPE
      '
      if a=123 then
        c=swd : capture(wr,b,b,m) : skiplspace(wr,b)
        'w3+=mid(wr,c,b-c)+cr
        'mid(wr,c)=space(b-c)
        e=b : continue do
      end if
    end if 'mo=2
    '
    '
    'BODY ELEMENTS?
    '
    'SKIP BRACKETS
    '-------------
    '
    if ascn=lbr then
      capture(wr,b,b,m) : skiplspace(wr,b)
    end if
    '
    '
    'EXCISE #IF etc
    '--------------
    '
    if ascw=35 then
      md=0 : if mc=-13 then md=maco(mp,3)
      if md>=100 then
        metaco(wr,b) : if ert then exit do else continue do
      end if
    end if
    '
    if w1="#byref" then bref=1
    if w1="#byval" then bref=0
    '
    'EXCISE FLAGS
    '------------
    '
    if w1="packed" then
      w3+=mid(wr,e,b-e) : w1=tword(wr,b) ' follow on for type typdef class
    end if
    '
    'EXCISE BODY BLOCKS
    '------------------
    '
    'except UNION
    '
    if instrword(" ( { def type class interface operations methods typedef defs struct enum ",w1) then
      captured(wr,b,m,a,w1)
      if mo=2 then w3+=mid(wr,e,b-e) : mid(wr,e)=space(b-e)
      e=b : continue do
    end if
    '
    'EXCISE DECLARATIVES ETC
    '-----------------------
    '
    '
    a=0
    if mo=2 then
      if instrword(" declare %  dim global #def #define ### #view #endv var #byref #byval #indexbase indexbase ",w1) then a=1
    end if
    '
   '
    '========
    classign:
    '========
    '
    if asCn=61 then a=1 'ASSIGNMENTS itr array assignments
    '
    if a then
      endcomcomline(wr,b) : b+=2
      w3+=mid(wr,e,b-e) : mid(wr,e)=space(b-e)
      e=b
      continue do
    end if
    '
    'LOOKAHEAD FOR METHOD/FUNCTION/SUB BODY
    '--------------------------------------
    '
    a=instrword (" method methods function sub macro type class ",w1)
    '
    if a then
      if w1="sub" then
        a=issub(wr,b) 'EXCLUDE ASM SUB
      end if
    end if
    '
    '
    if a then
      '
      c=swd : d=0 : f=b
      if mo=1 then e=c
      CaptProcHead(wr,b)
      '
      'B NOW INDEXES BOUNDARY OF PROTOTYPE
      '
      CaptProcBody(w1,wr,b,d)
      '
     '
      'CAPTURE METHOD OR BLOCK
      '-----------------------
      '
      a=0
      if mo=2 then
        if w1="method" then a=1
      else
        a=instrword(" function sub ",w1)
      end if
      '
      if a then
        w1=mid(wr,e,b-e)
        if mo=1 then
          w4+="declare " 'TO MAKE DECLARATION HEADERS
        end if
        w4+=w1+cr       'CAPTURE HEADER INCLUDING QUALIFIERS
      end if
      '
      if mo=2 then
        if d=0 then
          if a then mid(wr,e)=space(b-e) 'OMIT METHOD HEADER FROM BODY
        else 'd>0
          w3+=lns+mid(wr,c,d-c) 'CAPTURE WHOLE PROCEDURE EXCLUDING QUALIFIERS
          '
          'body present
          '
          mid(wr,e)=space(d-e) 'OMIT WHOLE METHOD/FUNCTION/SUB AND QUALIFIERS
          b=d 
        end if 'd
      end if 'mo=2
      '
      if mo=1 then if d then b=d
      '
      e=b 'UPDATE POSITION FOR NEXT ITEMS
    end if
  loop
  '
  if mo<>2 then exit sub
  '
  '
  'REMOVE EMPTY LINES
  '==================
  '
  b=1
  e=len(wr)
  c=1
  do
    if b>e then exit do
    a=asc(wr,b)
    if a=13 then
      b+=2
      wr=left(wr,c-1)+mid(wr,b) 'remove empty line
      b=c
      e=len(wr)
      continue do
    end if
    if a<>32 then endline(wr,b) : b+=2 : c=b : continue do
    b+=1 'if a=32 
  loop
  '
  'ENSURE PUBLIC DEFAULT
  '=====================
  '
  if len(w4) then
    wr="public"+cr+wr
  end if

  '
end sub




